/******************************************************************************************************************************************************
 * Name         :   ScenarioTriggerHandler.cls
 * Description  :   This class for will use as Handler class for scenarioTrigger
 * Author       :   Arun Kumar
 * Created On   :   July 2017
******************************************************************************************************************************************************/
public with sharing class ScenarioTriggerHandler{
    
    // Set to control the recursive trigger calls
    public static Set<Id> secnarioIdsToAvoidRecursion = new Set<Id>();

    //This method will call the webservice callout and start the copy process based on EndPoints
    public static void InitiateETLProcessV2(Scenario__c scenarioObj, string action){
        system.debug('#### InitiateETLProcess called for '+action);
        boolean hasBusinessRuleTemplate = false;
        if(scenarioObj.Business_Rule_Template__c != null){
            hasBusinessRuleTemplate = true;
        }
        
        system.debug('#### Skip_Data_Validation__c : '+scenarioObj.Skip_Data_Validation__c);
        /*if(action.toLowerCase() != 'delete' && scenarioObj.Skip_Data_Validation__c){
            system.debug('#### Invoke talend service');
            InitiateETLProcess(scenarioObj,action);
        }else{
            system.debug('#### Invoke python service');
            ETLWebServiceCallOut(action, scenarioObj.Id, scenarioObj.Source_Team_Instance__c, scenarioObj.Team_Instance__c, scenarioObj.File_Path__c, hasBusinessRuleTemplate, scenarioObj.Skip_Data_Validation__c);
        }*/
//SIQ-3090 Always call Python service
        //if(action.toLowerCase()=='insert' || action.toLowerCase()=='delete'){
            ETLWebServiceCallOut(action, scenarioObj.Id, scenarioObj.Source_Team_Instance__c, scenarioObj.Team_Instance__c, scenarioObj.File_Path__c, hasBusinessRuleTemplate, scenarioObj.Skip_Data_Validation__c);
        
        
        /*}else{
        
            InitiateETLProcess(scenarioObj,action);
        }*/
    }

    public static string getAccountDataObjectId(){
        list<Data_Object__c> dataObj = [SELECT Id FROM Data_Object__c where Data_Set_Object_Name__c in ('Account') limit 1];
        if(dataObj.size() == 1){
            system.debug('#### dataObjId : '+dataObj[0].Id);
            return dataObj[0].Id;
        }else{
            return '';
        }
    }
    //siq:4409
    public static void collabrationScenario(Scenario__c sc){
        sc.Employee_Assignment__c = true;
        sc.CR_Tracking__c = true;
        sc.Scenario_Stage__c = Label.Collaboration_Stage_Label;
        sc.Request_Process_Stage__c = 'In Progress';
        update sc;
    }

    @future(callout=true)
    public static void ETLWebServiceCallOut(string action, id scenarioId, string sourceTeamInstance, string destinationTeamInstance, string filePath, boolean hasBusinessRuleTemplate, boolean skipDataValidation){
        system.debug('#### ETLWebServiceCallOut called for '+action);
        try{
            list<ETL_Config__c> objETL = ScenarioUtility.getETLConfigByName(SalesIQGlobalConstants.PYTHON_JOB);
            system.debug('#### EndPoint : '+objETL[0].End_Point__c);
            system.debug('#### SFUserName : '+objETL[0].SF_UserName__c);
            system.debug('#### SF_Password__c : '+objETL[0].SF_Password__c);
            system.debug('#### Org_Type__c : '+objETL[0].Org_Type__c);
            system.debug('#### Securitytoken : '+objETL[0].S3_Security_Token__c);

            if(objETL[0].SF_UserName__c == null || objETL[0].SF_UserName__c == null || objETL[0].SF_Password__c == null || objETL[0].Org_Type__c == null || objETL[0].S3_Security_Token__c == null){
                //Throw error
            }else{
                string TalendEndpoint = objETL[0].End_Point__c;
                String ns = SalesIQGlobalConstants.NAME_SPACE;
                String copyScenarioWhereClause = '';

                Scenario__c scenarioGeoType = [select Id, Team_Instance__r.Geography_Type_Name__r.Shape_Available__c,  Team_Instance__r.Geography_Type_Name__r.Account_Shape_Available__c from Scenario__c where Id =: scenarioId];

                // SIQ-3285, pass where clause only when copy scenario auto execution is ON
                List<Server_Thresholds__c> copyScenarioAutoExecution = [SELECT Load_Count__c FROM Server_Thresholds__c where Name = 'Skip Copy Auto Execution'];

                if(hasBusinessRuleTemplate && copyScenarioAutoExecution.isEmpty()){
                    copyScenarioWhereClause = ns+'Team_Instance__c = \''+sourceTeamInstance+ '\' AND '+ ns+'Account_Alignment_Type__c = \'Explicit\' AND ' + ns+'Assignment_Status__c = \'Active\' AND '+ ns+'Affiliation_Based_Alignment__c = FALSE';
                }
                
                TalendEndpoint += '?sf_username='+objETL[0].SF_UserName__c;
                TalendEndpoint += '&sf_password='+objETL[0].SF_Password__c;
                TalendEndpoint += '&sf_token='+objETL[0].S3_Security_Token__c;
                if(objETL[0].Org_Type__c.toLowerCase() == 'test'){
                    TalendEndpoint += '&sf_sandbox=true';
                }else{
                    TalendEndpoint += '&sf_sandbox=false';
                }
                TalendEndpoint += '&namespace='+SalesIQGlobalConstants.NAME_SPACE;
                TalendEndpoint += '&action='+action;
                TalendEndpoint += '&scenario_id='+scenarioId;
                if(action.toLowerCase() == 'copy'){
                    TalendEndpoint += '&source_team_instance_id='+sourceTeamInstance;
                }
                TalendEndpoint += '&dest_team_instance_id='+destinationTeamInstance;
                
                if(action.toLowerCase() == 'insert'){
                    TalendEndpoint += '&filepath='+filePath;
                }
                if(action == 'callplaninsert'){
                    TalendEndpoint += '&is_esri_sync=false';
                }else{
                    //SIQ-4165
                    if(scenarioGeoType.Team_Instance__r.Geography_Type_Name__r.Shape_Available__c){
                        TalendEndpoint += '&is_esri_sync=true';

                    }else{
                        TalendEndpoint += '&is_esri_sync=false';
                    }
                    
                }                
                
                TalendEndpoint += '&is_master_data=false';
                if(action == 'copy'){
                    TalendEndpoint += '&copy_filter='+copyScenarioWhereClause;
                }
                TalendEndpoint += '&skip_validation='+skipDataValidation;
                TalendEndpoint += '&data_object_ids='+getAccountDataObjectId();

                system.debug('#### TalendEndpoint : '+TalendEndpoint);
                
                Http h = new Http();
                HttpRequest request = new HttpRequest();
                TalendEndpoint = TalendEndpoint.replaceAll( '\\s+', '%20');
                request.setEndPoint(TalendEndpoint);
                request.setHeader('Content-type', 'application/json');
                request.setMethod('GET');
                request.setTimeout(20000);
                system.debug('request '+request);
                HttpResponse response = h.send(request);
                system.debug('#### Talend copy Response : '+response);
            }
        }catch(Exception e){
            system.debug('#### ERROR : '+e.getMessage());
        }
    }


    //This method will call the webservice callout and start the copy process based on EndPoints
    public static void InitiateETLProcess(Scenario__c scenarioObj, string action){
        system.debug('#### InitiateETLProcess called for '+action);
        try{
            string EndPoints='';
            string SFUserName='';
            string SFPassword='';
            string ActivityLogId='';
            string OrgType = '';
            
            list<ETL_Config__c> lstETLInfo = ScenarioUtility.getETLConfigByName(SalesIQGlobalConstants.TALEND_JOB);
            if(lstETLInfo != null && lstETLInfo.size() > 0){
                for(ETL_Config__c objETL : lstETLInfo){
                    EndPoints = objETL.End_Point__c;
                    SFUserName = objETL.SF_UserName__c;
                    SFPassword = objETL.SF_Password__c;
                    OrgType = objETL.Org_Type__c;
                }

                if(action == 'copy' && scenarioObj.Source_Team_Instance__c != null && scenarioObj.Team_Instance__c != null && SFUserName != ''){
                    Activity_Log__c activityLog = ScenarioUtility.createIntegrationActivityLog('Copy Job');
                    if(!string.isBlank(activityLog.Name)){
                        ActivityLogId = activityLog.id;
                    }
                    system.debug('#### calling ETLWebServiceCallOutForCopy');
                    ETLWebServiceCallOutForCopy(EndPoints, scenarioObj.id, scenarioObj.Source_Team_Instance__c, scenarioObj.Team_Instance__c, SFUserName,SFPassword, ActivityLogId, OrgType);
                }else if(action == 'insert' && scenarioObj.Team_Instance__c != null && SFUserName != ''){
                    Activity_Log__c activityLog = ScenarioUtility.createIntegrationActivityLog('Insert Job');
                    if(!string.isBlank(activityLog.Name)){
                        ActivityLogId = activityLog.id;
                    }
                    system.debug('#### calling ETLWebServiceCallForInsert');
                    ETLWebServiceCallForInsert(EndPoints, scenarioObj.id, scenarioObj.Team_Instance__c, SFUserName, SFPassword, ActivityLogId, scenarioObj.File_Path__c,action, OrgType);
                }else if(action == 'callplaninsert' && scenarioObj.Team_Instance__c != null && SFUserName != ''){
                    Activity_Log__c activityLog = ScenarioUtility.createIntegrationActivityLog('Insert Call Plan Job');
                    if(!string.isBlank(activityLog.Name)){
                        ActivityLogId = activityLog.id;
                    }
                    system.debug('#### calling ETLWebServiceCallForInsert for call plan');
                    ETLWebServiceCallForInsert(EndPoints, scenarioObj.id, scenarioObj.Team_Instance__c, SFUserName, SFPassword, ActivityLogId, scenarioObj.File_Path__c,action, OrgType);
                }else if(action == 'delete' && scenarioObj.Team_Instance__c != null && SFUserName != ''){
                    Activity_Log__c activityLog = ScenarioUtility.createIntegrationActivityLog('Delete Job');
                    if(!string.isBlank(activityLog.Name)){
                        ActivityLogId = activityLog.id;
                    }
                    system.debug('#### calling ETLWebServiceCallOutForDelete');
                    ETLWebServiceCallOutForDelete(EndPoints, scenarioObj.id, scenarioObj.Team_Instance__c, SFUserName, SFPassword, ActivityLogId, OrgType);
                }else{
                    system.debug('#### No condition matched');
                }
            }
            
        }catch(exception ex){
            system.debug('#### ERROR : '+ex.getMessage());
        }
    }
    
    //This method will return if scenario list is avalble.
    public static boolean isValidScenario(list<string> ScenarioStages ,list<string> ScenarioStageStatus, string scenarioType, set<Id> Scenario){
        boolean Isvalid = true;
        list<Scenario__c> lstScenario = ScenarioUtility.getScenarioByRequestName(ScenarioStages,ScenarioStageStatus,scenarioType,Scenario);
        if(lstScenario!=null && lstScenario.size() > 0){
            Isvalid = false;
        }
        system.debug('#### Isvalid : '+Isvalid);
        return Isvalid;
    }

    //Method to find Scenarios in "Delete In Queue" stage and invoke Delete ETL job
    public static void deleteScenarioInQueue(){
        list<Scenario__c> lstQueueScenario = ScenarioUtility.getScenarioByRequestName(new list<string>{SalesIQGlobalConstants.DESIGN,SalesIQGlobalConstants.COLLABORATION}, new list<string>{SalesIQGlobalConstants.DELETE_IN_QUEUE}, 'Alignment Scenario',new set<id>{});
        if(lstQueueScenario != null && lstQueueScenario.size() > 0){
            InitiateETLProcessV2(lstQueueScenario[0], 'delete');
        }
    }
    
    @future(callout=true)
    public static void ETLWebServiceCallOutForCopy(string EndPoints, id ScenarioId, string SourceTeamInstance, string DestinationTeamInstance , string SFUserName, string SFPassword, string ActivityLog, string OrgType){
        system.debug('#### ETLWebServiceCallOutForCopy called');
        string TalendEndpoint=EndPoints; 
        try{
            String copyScenarioWhereClause = '';
            String ns = SalesIQGlobalConstants.NAME_SPACE;

            List<Scenario__c> scenarioList = new List<Scenario__c>();
            
            if( ScenarioId != null ){
                scenarioList = [ select id from Scenario__c where Business_Rule_Template__c <> null and id = :ScenarioId ];
            }

            if( scenarioList != null && scenarioList.size() > 0 ){
                copyScenarioWhereClause = ns+'Team_Instance__c = \''+SourceTeamInstance+ 
                '\' AND '+ ns+'Account_Alignment_Type__c = \'Explicit\' AND ' + ns+'Assignment_Status__c = \'Active\' AND '+ ns+'Affiliation_Based_Alignment__c = FALSE';
            }

            TalendEndpoint += '&arg0=--context_param salesiq_userPassword_userId='+SFUserName;
            TalendEndpoint += '&arg1=--context_param salesiq_userPassword_password='+SFPassword;
            TalendEndpoint += '&arg2=--context_param salesiq_scenarioid='+ScenarioId;
            TalendEndpoint += '&arg3=--context_param salesiq_sourceteaminst='+SourceTeamInstance;
            TalendEndpoint += '&arg4=--context_param salesiq_action=copy';
            TalendEndpoint += '&arg5=--context_param salesiq_ismasterdata=false';
            TalendEndpoint += '&arg6=--context_param salesiq_esri_operation=true';
            TalendEndpoint += '&arg7=--context_param salesiq_destteaminst='+DestinationTeamInstance;
            TalendEndpoint += '&arg8=--context_param salesiq_activitylogid='+ActivityLog;
            TalendEndpoint += '&arg9=--context_param salesiq_orgtype='+OrgType;
            TalendEndpoint += '&arg10=--context_param salesiq_pa_where_clause='+copyScenarioWhereClause;

            system.debug('#### TalendEndpoint : '+TalendEndpoint);
            
            Http h = new Http();
            HttpRequest request = new HttpRequest();
            TalendEndpoint = TalendEndpoint.replaceAll( '\\s+', '%20');
            request.setEndPoint(TalendEndpoint);
            request.setHeader('Content-type', 'application/json');
            request.setMethod('GET');
            request.setTimeout(20000);
            system.debug('request '+request);
            HttpResponse response = h.send(request);
            system.debug('#### Talend copy Response : '+response);
        }
        catch(exception ex){
            system.debug('Error in ETLWebServiceCallOut : '+ex.getMessage());
        }
    }
	//SIMPS-1146 : Copy alignment success/failure notification to the user who is copying the scenario
	@future(callout=true)
    public static void validateCopyScenarioData(String sourceTeamInstance, String destinationTeamInstance) {
        system.debug('#### validateCopyScenarioData called for '+sourceTeamInstance);
        //string serverUrl = 'http://52.24.8.231/copy_stats_unmanaged/view';
        try{

            //GET OWNER FROM TEAM INSTANCE 
            List<Team_Instance__c> teamInstance = [select ownerid from Team_Instance__c where id = :destinationTeamInstance];

            Id userId = teamInstance[0].ownerid;
            List<User> userRecord = [select Email from User where id = :userId limit 1];

            String emailId = userRecord[0].Email;
            system.debug('emailId :'+emailId);
            //emailId = 'ankit.mehrotra@axtria.com';

            string EndPoints='';
            string SFUserName='';
            string SFPassword='';
            string SFsecurityToken='';
            string SFSandbox='';
            
            
            list<ETL_Config__c> lstETLInfo = ScenarioUtility.getETLConfigByName(SalesIQGlobalConstants.COPY_VALIDATION);
            if(lstETLInfo != null && lstETLInfo.size() > 0){
                for(ETL_Config__c objETL : lstETLInfo){
                    EndPoints = objETL.End_Point__c;
                    SFUserName = objETL.SF_UserName__c;
                    SFPassword = objETL.SF_Password__c;
                    SFsecurityToken = objETL.S3_Security_Token__c;
                    String url = EndPoints+'?sf_username='+SFUserName+
                    '&sf_password='+SFPassword+'&sf_token='+SFsecurityToken+'&sf_sandbox='+SalesIQUtility.isSandboxOrg()+
                    '&source_team_instance_id='+sourceTeamInstance+'&dest_team_instance_id='+destinationTeamInstance;
        
                system.debug('url>>>'+url);
                //Preparing for the callout. Response is in JSON
                Http h = new Http();
                HttpRequest request = new HttpRequest();
                url = url.replaceAll( '\\s+', '%20');
                request.setEndPoint(url);
                request.setHeader('Content-type', 'application/json');
                request.setMethod('GET');
                request.setTimeout(20000);
                system.debug('request '+request);
                HttpResponse response = h.send(request);
                system.debug('#### Validate copy Response : ');
                system.debug(response.getBody());

                String emailBody = '';
                //Parsing JSON
                Map<String,Object> m1 = (Map<String,Object>)JSON.deserializeUntyped(response.getBody());
                   system.debug(m1 + 'm1');
                   emailBody = '<p>Please find copied scenario results</p>';
                   emailBody += '</br>';
				   
				   emailBody = '<table border="1" style="border-collapse: collapse"><caption>Request Summary Data</caption><tr><th>Object Name</th><th>Source Count</th><th>Destination Count</th></tr>';

                for(String s : m1.keySet()){
                    if(m1.get(s) == true){
                        continue;
                    }
                    Map<String,Object> ss = (Map<String,Object>)m1.get(s);
                    //emailBody += ' Object Name : '+s + ' Source Count : '+String.valueOf(ss.get('destination_count'))+ 'Destination Count : '+String.valueOf(ss.get('source_count'));
                    emailBody += '<tr><td>'+ s + '</td><td>' + String.valueOf(ss.get('source_count')) + '</td><td>' +String.valueOf(ss.get('destination_count'))+'</td></tr>';
                    system.debug('destination_count' + String.valueOf(ss.get('destination_count')));
                    system.debug('source_count' + String.valueOf(ss.get('source_count')));
                }
				emailBody += '</table>';

                emailBody += '</br>';

                emailBody += 'Mismatch is : '+String.valueOf(m1.get('Mismatch'));

                system.debug(emailBody);

                system.debug(emailBody);
                
                ScenarioTriggerHandler.sendEmail(emailId,emailBody);
               }
            }
        }       
    
        catch(exception ex){
            system.debug('#### ERROR : '+ex.getMessage());
        }
        
} 	
	//SIMPS-1146 : Copy alignment success/failure notification to the user who is copying the scenario 
    public static void sendEmail(String emailId,String emailBody) {
        List<Scenario__c> sc = new List<Scenario__c>();
        sc = [select id, CreatedById from scenario__c];
        String subject = 'Notification about the scenario status';
        //String body = emailBody';
        Messaging.SingleEmailMessage email = new Messaging.SingleEmailMessage();
        //Set the parameters of the email object
        email.setSubject(subject);
        email.setToAddresses(new String[] {emailId});
        //string [] toaddress= New string[]{'ankit.mehrotra@axtria.com'};
        //email.setToAddresses(toaddress);
        email.setHtmlBody(emailBody);
        //sends the email
        try{
           Messaging.SendEmailResult [] results = Messaging.sendEmail(new Messaging.SingleEmailMessage[] {email});
        }
        catch(exception e){
            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.ERROR, e.getMessage()));
        }
    }

    @future(callout=true)
    public static void ETLWebServiceCallForInsert(string EndPoints, id ScenarioId, string TeamInstance , string SFUserName, string SFPassword, string ActivityLog, string FilePath,string Action, string OrgType){
        system.debug('#### ETLWebServiceCallForInsert called for '+Action);
        string TalendEndpoint=EndPoints; 
         
        try{
            TalendEndpoint += '&arg0=--context_param salesiq_userPassword_userId='+SFUserName;
            TalendEndpoint += '&arg1=--context_param salesiq_userPassword_password='+SFPassword;
            TalendEndpoint += '&arg2=--context_param salesiq_scenarioid='+ScenarioId;
            TalendEndpoint += '&arg3=--context_param salesiq_sourceteaminst='+TeamInstance;
            TalendEndpoint += '&arg4=--context_param salesiq_action='+Action;
            TalendEndpoint += '&arg5=--context_param salesiq_ismasterdata=false';
            if(action == 'callplaninsert'){
                TalendEndpoint += '&arg6=--context_param salesiq_esri_operation=false';
            }else{
                TalendEndpoint += '&arg6=--context_param salesiq_esri_operation=true';
            }
            
            TalendEndpoint += '&arg7=--context_param salesiq_filepath='+FilePath;
            TalendEndpoint += '&arg8=--context_param salesiq_activitylogid='+ActivityLog;
            TalendEndpoint += '&arg9=--context_param salesiq_orgtype='+OrgType;

            system.debug('#### TalendEndpoint : '+TalendEndpoint);
            
            Http h = new Http();
            HttpRequest request = new HttpRequest();
            TalendEndpoint = TalendEndpoint.replaceAll( '\\s+', '%20');
            request.setEndPoint(TalendEndpoint);
            request.setHeader('Content-type', 'application/json');
            request.setMethod('GET');
            request.setTimeout(20000);
            system.debug('request '+request);
            HttpResponse response = h.send(request);
            system.debug('#### Talend Insert Response : '+response);
            
        }
        catch(exception ex){
            system.debug('Error in ETLWebServiceCallOut : '+ex.getMessage());
        }
    }

    @future(callout=true)
    public static void ETLWebServiceCallOutForDelete(string EndPoints, id ScenarioId, string TeamInstance , string SFUserName, string SFPassword, string ActivityLogId, string OrgType){
        system.debug('#### ETLWebServiceCallOutForDelete called');
        string TalendEndpoint=EndPoints; 
         
        try{
            TalendEndpoint += '&arg0=--context_param salesiq_userPassword_userId='+SFUserName;
            TalendEndpoint += '&arg1=--context_param salesiq_userPassword_password='+SFPassword;
            TalendEndpoint += '&arg2=--context_param salesiq_scenarioid='+ScenarioId;
            TalendEndpoint += '&arg3=--context_param salesiq_sourceteaminst='+TeamInstance;
            TalendEndpoint += '&arg4=--context_param salesiq_action=delete';
            TalendEndpoint += '&arg5=--context_param salesiq_ismasterdata=false';
            TalendEndpoint += '&arg6=--context_param salesiq_esri_operation=true';
            TalendEndpoint += '&arg7=--context_param salesiq_activitylogid='+ActivityLogId;
            TalendEndpoint += '&arg8=--context_param salesiq_orgtype='+OrgType;
            
            system.debug('#### TalendEndpoint : '+TalendEndpoint);

            Http h = new Http();
            HttpRequest request = new HttpRequest();
            TalendEndpoint = TalendEndpoint.replaceAll( '\\s+', '%20');
            request.setEndPoint(TalendEndpoint);
            request.setHeader('Content-type', 'application/json');
            request.setMethod('GET');
            request.setTimeout(20000);
            system.debug('request '+request);
            HttpResponse response = h.send(request);
            system.debug('#### Talend Delete Response : '+response);
        }
        catch(exception ex){
            system.debug('Error in ETLWebServiceCallOutForDelete : '+ex.getMessage());
        }
    }

    /*
    * This method will mark all other scenario inactive when RequestProcessStage is in either Design or Collaboration
    * Fetch all scenario based on source team intance other than currently updated scenario
    * Modified on 10/24/2018 | SIQ-2830 | 
    * When employee assignment is enabled on a scenario, all other active scenarios (created from file or copy existing) in the same team with stage equal to design or collaboration will be inactivated.
    */
    public static void UpdateScenarioToInactive(list<Scenario__c> Scenario){

        map<string, list<Scenario__c>> mapTeamInstanceScenario = new map<string, list<Scenario__c>>();
        set<id> scenarioId = new set<id>();
         list<Scenario__c> lstOtherScenario =null; 
         try{
            for(Scenario__c sc:Scenario){
                scenarioId.add(sc.id);
                list<Scenario__c> tempScenarioList = mapTeamInstanceScenario.get(sc.Team_Name__c);
                if(tempScenarioList == null){
                    tempScenarioList = new list<Scenario__c>();
                }
                tempScenarioList.add(sc);
                mapTeamInstanceScenario.put(sc.Team_Name__c, tempScenarioList);
            }
            system.debug('inScenario '+scenarioId);
            system.debug('mapTeamInstanceScenario '+mapTeamInstanceScenario);

            if(mapTeamInstanceScenario.size() > 0 && scenarioId.size() > 0){
                lstOtherScenario = new list<Scenario__c>();
                list<string> SCENARIO_READ_FIELD = new list<string>{'Source_Team_Instance__c','Scenario_Status__c'};
                list<string> SCENARIO_UPDATE_FIELD = new list<string>{'Scenario_Status__c'};
                if(SecurityUtil.checkRead(Scenario__c.SObjectType, SCENARIO_READ_FIELD, false)){
                    lstOtherScenario = [select id, Scenario_Status__c, Scenario_Stage__c from Scenario__c where id not in : scenarioId and 
                                        Scenario_Status__c =: SalesIQGlobalConstants.SCENARIO_STATUS_ACTIVE and Team_Name__c in : mapTeamInstanceScenario.keyset() and 
                                        (Scenario_Stage__c =: SalesIQGlobalConstants.DESIGN OR Scenario_Stage__c =: SalesIQGlobalConstants.COLLABORATION) 
                                        AND Scenario_Type__c != 'Call Plan Generation'];

                    if(lstOtherScenario != null && lstOtherScenario.size() > 0){
                        for(Scenario__c scupdate : lstOtherScenario){
                            scupdate.Scenario_Status__c = SalesIQGlobalConstants.SCENARIO_STATUS_INACTIVE;
                        }

                        if(SecurityUtil.checkUpdate(Scenario__c.SObjectType, SCENARIO_UPDATE_FIELD, false)){
                            update lstOtherScenario;
                        }
                    }
                }
            }
        }catch(exception ex){
            system.debug('error in UpdateScenarioToInactive '+ex.getMessage());
        }
    }
    
    // update userposition records while triggerupdate
    // make record active and update assigned position
    
    public static void updateUserPosition(list<Scenario__c> ScenarioList){
        system.debug('####  updateUserPosition called');
        // create map for scenario team_instance and scenario
        map<String,Scenario__c> teamInstanceScenarioMap = new map<String,Scenario__c>();
        set<String> teamInstanceSet = new set<String>();
        set<String> scenarioNameSet = new set<String>();
        set<String> baseScenarioNameSet = new set<String>();
        string sScenarioTytpe='';
        
        for(Scenario__c sce : ScenarioList){
            if(sce.Request_Process_Stage__c == SalesIQGlobalConstants.READY ){
                System.debug('******* activate scenario user position records *******');
                System.debug('sceanrio created in UserPosition Method '+sce);
                teamInstanceSet.add(sce.Team_Instance__c);
                scenarioNameSet.add(sce.Scenario_Name__c);
                sScenarioTytpe =sce.Team_Type__c;
            }
        }
        system.debug('baseScenarioNameSet:'+baseScenarioNameSet);
        // map for teamInstance and posiiton for updating useraccess positons
        map<Id,Position__c> scPositionMap = new map<Id,Position__c>();
        list<CR_Team_Instance_Config__c> crTeamInstConfig = [select Configuration_Value__c from CR_Team_Instance_Config__c where Team_Instance__c in : teamInstanceSet and 
                                                            Configuration_Type__c =: SalesIQGlobalConstants.HIERARCHY_CONFIG order by Hierarchy_Level_Number__c desc limit 1];

        string topLevelPosition = 'Nation';
        if(crTeamInstConfig.size() > 0){
            topLevelPosition = crTeamInstConfig[0].Configuration_Value__c;
            topLevelPosition = topLevelPosition.replace('Label.','');
        }

        //Below variable will be use to save the base team instance id while creating the overlay Team. coz at the time of overlay creation, we need to fill Position field in 
        //user position access object. but for overlay team we never have seprate Nation. So we need to find the nation from the base_team_instance__c
        set<string> baseTeamInstanceset = new set<string>();
        map<Id,Id> baseteamOverlayMap = new map<Id, Id>();

        if(sScenarioTytpe==SalesIQGlobalConstants.TEAM_TYPE_OVERLAY){
            list<Team_Instance__c> lstTeamInstance = [select id, base_team_instance__c, base_team_instance__r.Name, base_team_instance__r.id, Converging_Level__c from Team_Instance__c where id in:teamInstanceSet]; 
            for(Team_Instance__c teamInst: lstTeamInstance){
                if(teamInst.Converging_Level__c>0){
                    baseTeamInstanceset.add(teamInst.base_team_instance__c);
                    baseScenarioNameSet.add(teamInst.base_team_instance__r.Name);
                    baseteamOverlayMap.put(teamInst.id, teamInst.base_team_instance__c);
                }

            }
        }

        list<Position__c> scenarioTeamInstancePositionList = null;
        system.debug('####  baseTeamInstanceset: '+baseTeamInstanceset);
        system.debug('####  baseteamOverlayMap: '+baseteamOverlayMap);
        if(!baseTeamInstanceset.isEmpty()){
            //THis condition will called when team instance has some converging level and we need to find the lopo level position from it's base team instance
            scenarioTeamInstancePositionList = ScenarioUtility.getPositionFromScenarioTeamInstance(baseTeamInstanceset,topLevelPosition);

        }else{
            scenarioTeamInstancePositionList = ScenarioUtility.getPositionFromScenarioTeamInstance(teamInstanceSet,topLevelPosition);

        }

        //list<Position__c> scenarioTeamInstancePositionList = ScenarioUtility.getPositionFromScenarioTeamInstance(teamInstanceSet,topLevelPosition);
        system.debug('####  scenarioTeamInstancePositionList: '+scenarioTeamInstancePositionList);
        if(scenarioTeamInstancePositionList != null){
            for(Position__c pos: scenarioTeamInstancePositionList){
                scPositionMap.put(pos.Team_Instance__C ,pos);
            }
        }   
        
        system.debug('#### scPositionMap : '+scPositionMap);
        
        list<User_Access_Permission__c> userAccessList = ScenarioUtility.getUserAccessPermissionRecordFromScenario(teamInstanceSet,scenarioNameSet,'', new set<string>());
        system.debug('#### teamInstanceSet : '+teamInstanceSet);
        system.debug('#### scenarioNameSet : '+scenarioNameSet);
        system.debug('#### userAccessList : '+userAccessList);
        for(User_Access_Permission__c useracess : userAccessList){
            system.debug('#### scPositionMap.containsKey(useracess.Team_Instance__c) : '+scPositionMap.containsKey(useracess.Team_Instance__c));
            useracess.Is_Active__c = true;
            if(baseTeamInstanceset.isEmpty()){
                system.debug('## Base');
                if(scPositionMap.containsKey(useracess.Team_Instance__c)){
                    system.debug('in pos condition ');
                    Position__c pos =   scPositionMap.get(useracess.Team_Instance__c);
                    useracess.Map_Access_Position__c = pos.id;
                    useracess.Position__c = pos.id;
                }
            }
            else if(baseteamOverlayMap.containsKey(useracess.Team_Instance__c)){
                system.debug('## Overlay');
                if(scPositionMap.containsKey(baseteamOverlayMap.get(useracess.Team_Instance__c))){
                    Position__c pos =   scPositionMap.get(baseteamOverlayMap.get(useracess.Team_Instance__c));
                    useracess.Map_Access_Position__c = pos.id;
                    useracess.Position__c = pos.id;
                }
            }
            
        }
        
        if(userAccessList != null){
            update userAccessList;
        }
    }
    
    // this method will update team instance and make actions readonly while publishing stage and ready
    public static void updateTeamInstanceActionsReadOnly(list<Scenario__c> scenarioList){
        
        set<String> scInstanceSet = new set<String>();
        for(Scenario__c sc :scenarioList){
            scInstanceSet.add(sc.Team_Instance__c);
        }
        
        list<Team_Instance__c> teamInstanceListToUpdate = ScenarioUtility.getTeamInstancesFromScenario(scInstanceSet);
        for(Team_Instance__c instance : teamInstanceListToUpdate){
            instance.AccountMovement__c = true;
            instance.ReadOnlyCreatePosition__c = true;
            instance.ReadOnlyDeletePosition__c = true;
            instance.ReadOnlyEditPosition__c = true;
            instance.Restrict_Hierarchy_Change__c = true;
            instance.IsAllowedManageAssignment__c = true;
            instance.Restrict_Update_Position_Attribute__c = true;
            instance.ZIPMovement__c = true;
            instance.Restrict_ZIP_Share__c = true;
            instance.EnableAccountSharing__c = false;
        }
        
        list<String> TEAM_INSTANCE_UPDATE_FIELD = new list<String>{'AccountMovement__c','ReadOnlyCreatePosition__c','ReadOnlyDeletePosition__c','ReadOnlyEditPosition__c','Restrict_Hierarchy_Change__c','IsAllowedManageAssignment__c','Restrict_Update_Position_Attribute__c','ZIPMovement__c','Restrict_ZIP_Share__c','EnableAccountSharing__c'};
        if(SecurityUtil.checkUpdate(Team_Instance__c.SObjectType, TEAM_INSTANCE_UPDATE_FIELD, false)){
            System.debug('teamInstanceListToUpdate --'+teamInstanceListToUpdate);
            update teamInstanceListToUpdate;
        }
    }
    
    /*public static void updateTeamInstanceatLiveStage(list<Scenario__c> scenarioList){
        
        set<String> scInstanceSet = new set<String>();
        for(Scenario__c sc :scenarioList){
            scInstanceSet.add(sc.Team_Instance__c);
        }
        
        list<Team_Instance__c> teamInstanceListToUpdate = ScenarioUtility.getTeamInstancesFromScenario(scInstanceSet);
        for(Team_Instance__c instance : teamInstanceListToUpdate){
            
            instance.AccountMovement__c = false;
            instance.ReadOnlyCreatePosition__c = false;
            instance.ReadOnlyDeletePosition__c = false;
            instance.ReadOnlyEditPosition__c = false;
            instance.Restrict_Hierarchy_Change__c = false;
            instance.IsAllowedManageAssignment__c = false;
            instance.Restrict_Update_Position_Attribute__c = false;
            instance.ZIPMovement__c = false;
            instance.Restrict_ZIP_Share__c = false;
            //instance.EnableAccountSharing__c = false;
            
        }
        
        list<String> TEAM_INSTANCE_UPDATE_FIELD = new list<String>{'AccountMovement__c','ReadOnlyCreatePosition__c','ReadOnlyDeletePosition__c','ReadOnlyEditPosition__c','Restrict_Hierarchy_Change__c','IsAllowedManageAssignment__c','Restrict_Update_Position_Attribute__c','ZIPMovement__c','Restrict_ZIP_Share__c','EnableAccountSharing__c'};
        if(SecurityUtil.checkUpdate(Team_Instance__c.SObjectType, TEAM_INSTANCE_UPDATE_FIELD, false)){
            System.debug('teamInstanceListToUpdate --'+teamInstanceListToUpdate);
            update teamInstanceListToUpdate;
        }
    }*/

     /*
    METHOD TO CREATE SCENARIO LEVEL OBJECTS AND INVOKE TALEND SERVICE
    */

    public static void insertSalesIQScenarioDataObjects(String scenarioId, String templateid){
        try{
            
            List<Data_Set_Rule_Map__c> ruleMap = [select dataset_id__c from Data_Set_Rule_Map__c where Business_Rule_Template_Details__r.Business_Rule_Template_Id__c =: templateid and dataset_id__r.Is_Master__c = false and dataset_id__r.is_internal__c = false AND dataset_id__r.SalesIQ_Internal__c = true AND dataset_id__r.Data_Set_Object_Name__c != null];

            Set<Id> dataSetIds = new Set<Id>();
            for(Data_Set_Rule_Map__c dsMap : ruleMap) {
                dataSetIds.add(dsMap.dataset_id__c);
            }

            List<Data_Object__c> dataObjects = [select Id from Data_Object__c where dataset_id__c in :dataSetIds];

            List<String> externalDataSetIds  = new List<String>();
            for(Data_Object__c dObject : dataObjects) {
                externalDataSetIds.add(dObject.Id);
            }
            system.debug(externalDataSetIds);
            // SalesIQLogger.logErrorMessage(String.join(externalDataSetIds, ','),scenarioId);
            if(externalDataSetIds.size() > 0)
                syncExternalDataSourceFileToStaging(scenarioId,String.join(externalDataSetIds, ','));
        }catch(Exception ex){
            SalesIQLogger.logErrorMessage(ex.getStackTraceString(), SalesIQLogger.ALIGNMENT_UTILITY);
        }
    }

    /*
    METHOD TO INVOKE PYTHON SERVICE
    */
    @future (callout=true)
    public static void syncExternalDataSourceFileToStaging(String scenarioId, String scenarioLevelDataSetIds){
        try{
            ETL_Config__c etlObj = CPGUtility.getETLConfigByName(CPGConstants.talend_Instance);

            string pythonService = CPGUtility.getBRMSConfigValues('BRDataSync');
            //SSL CHANGES
            Map<String,String> urlParams = new Map<String,String>();
            urlParams.put('serviceUrl',pythonService);

            String sfUserName = etlObj.SF_UserName__c;
            String sfPassword = etlObj.SF_Password__c;
            String sfToken = etlObj.S3_Security_Token__c;
        
            //String url = pythonService+'?user_name='+sfUserName+'&password='+sfPassword+'&security_token='+sfToken+'&scenario_id='+scenarioId+'&dataObjectIds='+scenarioLevelDataSetIds+'&namespace='+SalesIQGlobalConstants.NAME_SPACE+'&sandbox='+SalesIQUtility.isSandboxOrg();
            String isSandbox = ( SalesIQUtility.isSandboxOrg() ) ? 'true' : 'false';
            urlParams.put('user_name',sfUserName);
            urlParams.put('password',sfPassword);
            urlParams.put('security_token',sfToken);
            urlParams.put('scenario_id',scenarioId);
            urlParams.put('dataObjectIds',scenarioLevelDataSetIds);
            urlParams.put('namespace',SalesIQGlobalConstants.NAME_SPACE);
            urlParams.put('sandbox',isSandbox);

            //SSL CHANGES
            //Http h = new Http();
            //HttpRequest request = new HttpRequest();
            //url = url.replaceAll( '\\s+', '%20');
            //request.setEndPoint(url);
            //request.setHeader('Content-type', 'application/json');
            //request.setMethod('GET');
            //request.setTimeout(120000);
            //system.debug('request '+request);
            //HttpResponse res = h.send(request);
            HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);

            System.debug('response: python -->' + res.getBody());
        }catch(exception ex){
            SalesIQLogger.logErrorMessage(ex.getStackTraceString(), SalesIQLogger.ALIGNMENT_UTILITY);
        }
    }

    /*
     METHOD TO CREATE CUSTOMER BLOCK WORKSPACES AFTER COUNTRY INSERT/UPDATE 
    */
    public static void insertCustomerBlockWorkspace(Id countryId){
        List<Workspace__c> existingWorkspaceList = new List<Workspace__c>();
        List<Workspace__c> newWorkspaceList = new List<Workspace__c>();
        try{

            /*CHECK FOR EXISTING WORKSPACES
            *IF THERE IS AN EXISTING WORKSPACE, 
            *IF THERE IT IS UNIVERSAL (PRODUCT BLOCK)
            *CONTINUE FOR OTHER COUNTRIES 
            */
            Business_Rule_Template__c template = [Select Id from Business_Rule_Template__c where isUniversal__c = true and isActive__c = true];
            if(template.id == null){
                return;
            }

            Boolean hasBlocklistWorkspaceAtCountry = false;
            existingWorkspaceList = [SELECT id , Country__c, isUniversal__c from Workspace__c where Country__c =:countryId and isUniversal__c = true];
            system.debug(' hasBlocklistWorkspaceAtCountry ::: '+ hasBlocklistWorkspaceAtCountry);
            system.debug(' existingWorkspaceList ::: '+ existingWorkspaceList);
            if(existingWorkspaceList != null && existingWorkspaceList.size() > 0 ){

                hasBlocklistWorkspaceAtCountry = true;
            }            

            system.debug(' hasBlocklistWorkspaceAtCountry ::: '+ hasBlocklistWorkspaceAtCountry);

            if(!hasBlocklistWorkspaceAtCountry){
                Workspace__c newWorkspace = new Workspace__c();
                newWorkspace.name = 'Exclusion Accounts Workspace';
                newWorkspace.Workspace_Start_Date__c = Date.today().toStartOfMonth();
                newWorkspace.Country__c = countryId;
                newWorkspace.Workspace_Description__c = 'Exclusion Accounts Workspace';
                newWorkspace.isUniversal__c = true;
                newWorkspaceList.add(newWorkspace);
            }

            if(newWorkspaceList!=null && newWorkspaceList.size()>0){
                insert newWorkspaceList;
                system.debug(' newWorkspaceList ::: '+ newWorkspaceList);
                insertCustomerBlockScenarios(newWorkspaceList,template);
            }
        }
        catch(Exception ex){
            System.debug('exception-->'+ex.getStackTraceString()+'~^'+ex.getMessage());
        }
       
    }

     /*
     METHOD TO CREATE INSERT CUSTOMER BLOCK SCENARIO AFTER WORKSPACE INSERT/UPDATE 
    */
    public static void insertCustomerBlockScenarios(List<Workspace__c> listWorkspaces, Business_Rule_Template__c template){
        List<Scenario__c> newScenarioList = new List<Scenario__c>();
        try{

            //GET DATA SOURCES 
            List<DataSourceWrapper> dataSourceWrapper = ScenarioCtlr.getCustomerMetricsOptions(template.Id);
            String dataSourceWrapperString = JSON.serialize(dataSourceWrapper);
            //CREATE BLOCK LIST SCENARIOS
            for(Workspace__c workspace :listWorkspaces)
            {

                SecurityUtil.checkRead(Workspace__c.SObjectType, new list<string>{'Workspace_Start_Date__c','Workspace_End_Date__c'}, false) ;
                String namespace=SalesIQGlobalConstants.NAME_SPACE;
                String objectAPIName = namespace+'Scenario__c' ;
                Id recordTypeId = Schema.getGlobalDescribe().get(objectAPIName).getDescribe().getRecordTypeInfosByName().get(SalesIQGlobalConstants.SCENARIO_TYPE_BLOCK_LIST).getRecordTypeId();
                Scenario__c scenarioObj = new Scenario__c();
                scenarioObj.Scenario_Name__c = 'Customer Block List';
                scenarioObj.Workspace__c = workspace.Id;
                scenarioObj.isUniversal__c = true;
                scenarioObj.Description__c = 'Customer Block List';
                scenarioObj.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
                scenarioObj.Effective_End_Date__c = workspace.Workspace_End_Date__c;
                scenarioObj.Scenario_Stage__c = 'Live';
                scenarioObj.Request_Process_Stage__c = 'Ready';
                scenarioObj.Scenario_Status__c = 'Active';
                scenarioObj.Scenario_Alignment_Level__c = 'National';
                scenarioObj.RecordTypeId = recordTypeId;
                scenarioObj.Scenario_Type__c = 'Rule Template';
                scenarioObj.CR_Tracking__c = false;
                scenarioObj.Business_Rule_Template__c = template.Id;
                
                newScenarioList.add(scenarioObj);

            }
            if(newScenarioList != null && newScenarioList.size()>0 ){

                SecurityUtil.checkInsert(Scenario__c.SObjectType, new list<string>{'Scenario_Name__c','Workspace__c','Team_Name__c','Source_Team_Instance__c','Effective_Start_Date__c','Effective_End_Date__c','Scenario_Stage__c','Request_Process_Stage__c','Scenario_Status__c','Scenario_Source__c'}, false) ;
                insert newScenarioList;

                for(Scenario__c scenario :newScenarioList){
                    //SAVE ON CANVAS
                    CPGUtility.getBusinessRuleDetails(template.Id,scenario.id);
                    ScenarioCtlr.saveOnDataObjectAndScenarioDataObjectMap(dataSourceWrapperString,scenario.id,template.Id,false);
                    updateScenarioDataObjectMap(scenario.id);
                }

            }

        }
        catch(Exception ex){
            System.debug('exception-->'+ex.getStackTraceString()+'~^'+ex.getMessage());
        }
   } 

   public static void updateScenarioDataObjectMap(id scenarioId)
    {
        List<Scenario_Data_Object_Map__c> scDataObjMapList = [Select id,Data_Set__c, Data_Set__r.Data_Set_Object_Name__c,Data_Object_Filter_Expression_Source__c,Filter_Expression_Destination__c,Filter_Expression_Source__c, Data_Object_Filter_Expression_Destn__c,Scenario__c,Data_Set__r.Column_Filter_Source__c,Data_Set__r.is_upstream__c, Data_Set__r.Column_Filter_Destination__c,Data_Set__r.Data_Filter_Value__c,Data_Set__r.Data_Filter_Operator__c from Scenario_Data_Object_Map__c where (Data_Set__r.SalesIQ_Internal__c = true or Data_Set__r.is_upstream__c = true) and Scenario__c =: ScenarioId];

        system.debug(scDataObjMapList);
        
        String ns = SalesIQGlobalConstants.NAME_SPACE;
        String filterQuery = 'select country__c from Scenario__c where id=:ScenarioId';
        
        system.debug('Scenario query ---> ' +filterQuery);
        Scenario__c myScenario = Database.query(filterQuery);
        string countryId = '';


        for(Scenario_Data_Object_Map__c scDataMapObj : scDataObjMapList)
        {
            if(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c') != null && scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Set_Object_Name__c') != ns + 'Team_Instance_Product__c' )
            {
                String sourceValue = '';
                String destinationValue = '';
                String dataFilterOperator = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Operator__c'));
                if(dataFilterOperator == null)
                {
                    dataFilterOperator = '{0}';
                }
                List<String> datafiltervalueTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c')).split(';');
                List<String> datafiltersourceTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Column_Filter_Source__c')).split(';');
                List<String> datafilterdestinationTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Column_Filter_Destination__c')).split(';');   

                /* ----------------- Code block by Aditi, for enhanced filter condition ----------------- */
                List<String> filterFullSourceConditions = new List<String>();
                List<String> filterFullDestinationConditions = new List<String>();
                for(Integer j = 0;j<datafiltervalueTempList.size();j++)
                {
                    String datafiltervalue = datafiltervalueTempList[j];
                    String sourceCondition = '', destinationCondition = '' ;
                    if(datafiltervalue.indexOf('Scenario__c') != -1) 
                    {
                        datafiltervalue = datafiltervalue.substring(datafiltervalue.indexOf('.')+1,datafiltervalue.length());
                        List<String> datafiltervalueList = datafiltervalue.split('\\.');
                
                        SObject intermediateObject = myScenario;
                        String finalFieldName = datafiltervalueList[0] ;
                        integer i = 0;
                        while(i < datafiltervalueList.size() - 1)
                        {
                            if(i == 0)
                            {
                                intermediateObject = myScenario.getSObject(datafiltervalueList[0]);
                            }
                            else
                            {
                                intermediateObject = intermediateObject.getSObject(datafiltervalueList[i]);
                            }
                            i = i+1;
                            finalFieldName = datafiltervalueList[i];
                        }

                        system.debug('Field Name FINAL ::' + finalFieldName);
                        countryId = string.valueOf(intermediateObject.get(finalFieldName));
                        
                        sourceCondition = datafiltersourceTempList[j] + ' = ' + '\''+ string.valueOf(intermediateObject.get(finalFieldName)) +'\'';
                        destinationCondition = datafilterdestinationTempList[j] + ' = ' + '\''+ string.valueOf(intermediateObject.get(finalFieldName)) +'\'';
                        
                    } 
                    else 
                    {
                        sourceCondition = datafiltersourceTempList[j] + ' = ' + datafiltervalueTempList[j];
                        if(datafiltervalueTempList[j].indexOf('\'') == -1)
                                destinationCondition = 'LOWER(' + datafilterdestinationTempList[j] + ') = ' + '\''+datafiltervalueTempList[j].toLowerCase()+'\'';
                        else
                            destinationCondition = datafilterdestinationTempList[j] + ' = ' + datafiltervalueTempList[j];
                    }

                    if(sourceCondition != '')
                        filterFullSourceConditions.add(sourceCondition);
                    if(destinationCondition != '')
                        filterFullDestinationConditions.add(destinationCondition);
                }

                scDataMapObj.Filter_Expression_Source__c = String.format(dataFilterOperator, filterFullSourceConditions);
                scDataMapObj.Filter_Expression_Destination__c = String.format(dataFilterOperator, filterFullDestinationConditions);
                
            }
            
            if(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c') != null && scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Set_Object_Name__c') == ns + 'Team_Instance_Product__c' )
            {
                String skey = ns+'Data_Set__c';
                String dataSetId = String.valueOf(scDataMapObj.get(skey));
                String expectedSourceColVal = ns+'Team__r.' + ns+'Country__c' ;
                List<Data_Set_Column_Detail__c> allColumns = [select Source_Column__c, tb_col_nm__c from Data_Set_Column_Detail__c where dataset_id__c =: dataSetId and Source_Column__c =: expectedSourceColVal];


                if(!allColumns.isEmpty()) {
                    string sourceValue = expectedSourceColVal + ' = ' + '\''+ countryId   + '\'';
                    string destinationValue = allColumns[0].tb_col_nm__c + ' = ' + '\''+ countryId  + '\'';
                    scDataMapObj.Filter_Expression_Source__c = sourceValue;
                    scDataMapObj.Filter_Expression_Destination__c = destinationValue;
                }
                
            }
        }
        
        system.debug(scDataObjMapList);
        update scDataObjMapList;
    }     

    public static boolean checkDuplicateWorkspaceName(Id userPersistanceCountryId, Id workspaceCountryId, String workspaceName){
        Boolean isDuplicate = false;
        system.debug('userPersistanceCountryId ::::::::  '+userPersistanceCountryId);
        system.debug('workspaceCountryId ::::::::  '+workspaceCountryId);
        system.debug('workspaceName ::::::::  '+workspaceName);
        id countryId = ( workspaceCountryId != null ) ? workspaceCountryId : userPersistanceCountryId;
        List<Workspace__c> workspaceList = [select id, Name from Workspace__c where Name =:workspaceName AND Country__c = :countryId];
        system.debug('workspaceList ::::::::  '+workspaceList);
        if( workspaceList != null && workspaceList.size() > 0 ){
            string name = String.valueOf(workspaceList[0].Name).toLowerCase();
            system.debug('name ::::::::  '+name);
            if (name.equals(workspaceName.toLowerCase())){
                isDuplicate = true;
            }
        }
        return isDuplicate;
    }  
    
    //update the CR_Tracking option in scenario
    public static void UpdateScenarioCRTracking(Scenario__c scenario){

        Scenario__c sc = [select CR_Tracking__c,KPI_Card_Guardrail_Config__c,Scenario_Type__c from Scenario__c where id =: scenario.Id]; 
        if(SecurityUtil.checkRead(Scenario__c.SObjectType, new list<String>{'CR_Tracking__c','KPI_Card_Guardrail_Config__c','Scenario_Type__c'}, false)){
            sc.CR_Tracking__c = true;
            if(sc.Scenario_Type__c == 'Call Plan Generation')
                sc.KPI_Card_Guardrail_Config__c = true;
        }
        System.debug('scenario update -'+sc);
        if(SecurityUtil.checkUpdate(Scenario__c.SObjectType, new list<string>{'CR_Tracking__c'}, false)){
            update sc;
        }
        
    }

    //update latesEmployeeAssignment flag for all scenarios in team
    public static void updateLatestEmployeeAssignment(list<Scenario__c> scenario){
        list<Scenario__c> scList = new list<Scenario__c>();
        set<String> scenarioIDs = new set<String>();
        set<String> teamName = new set<String>();
        for(Scenario__c sc : scenario){
            scenarioIDs.add(sc.Id);
            teamName.add(sc.Team_Name__c);
        }
        if(SecurityUtil.checkRead(Scenario__c.SObjectType, new list<String>{'IsLatest_Employee_Assignment__c','Team_Name__c'}, false)){
        scList = [select id,IsLatest_Employee_Assignment__c,Team_Name__c from Scenario__c where Team_Name__c  in : teamName]; 
            for(Scenario__c sc : scList)
            {
                if(scenarioIDs.contains(sc.Id))
                    sc.IsLatest_Employee_Assignment__c = true;
                else
                    sc.IsLatest_Employee_Assignment__c = false;
            }
        }
        System.debug('scList ::: '+scList);

        if(scList.size() >0){
            if(SecurityUtil.checkUpdate(Scenario__c.SObjectType, new list<string>{'IsLatest_Employee_Assignment__c'}, false)){
                update scList;
            }
        }

    }
}